#ifndef _KILIB_CTRL_H_
#define _KILIB_CTRL_H_
#include "window.h"
#ifndef __ccdoc__
namespace ki {
#endif



//=========================================================================
//@{ @pkg ki.Window //@}
//@{
//	Xe[^Xo[
//@}
//=========================================================================

class StatusBar : public Window
{
public:

	StatusBar();
	bool Create( HWND parent );
	int  AutoResize( bool maximized );
	void SetText( const TCHAR* str, int part=0 );
	void SetParts( int n, int* parts );

public:

	int width() const;

private:

	virtual bool PreTranslateMessage( MSG* );

private:

	int width_;
};



//-------------------------------------------------------------------------
#ifndef __ccdoc__

inline int StatusBar::width() const
	{ return width_; }

inline void StatusBar::SetParts( int n, int* parts )
	{ SendMsg( SB_SETPARTS, n, reinterpret_cast<LPARAM>(parts) ); }

#ifdef _UNICODE
inline void StatusBar::SetText( const TCHAR* str, int part )
	{ char mstr[600];
	::WideCharToMultiByte(CP_ACP,0,str,-1,mstr,sizeof(mstr),NULL,NULL);
	SendMsg( SB_SETTEXT, part, reinterpret_cast<LPARAM>(mstr) ); }
#else
inline void StatusBar::SetText( const TCHAR* str, int part )
	{ SendMsg( SB_SETTEXT, part, reinterpret_cast<LPARAM>(str) ); }
#endif



//=========================================================================

#endif // __ccdoc__
}      // namespace ki
#endif // _KILIB_CTRL_H_
