#include "stdafx.h"
#include "app.h"
#include "memory.h"
#include "string.h"
using namespace ki;



//=========================================================================

String::StringData* String::nullData_;
char                String::lb_[256];

void String::LibInit()
{
	static int nullstr_image[] = { 1, 1, 4, 0 };
	nullData_ = reinterpret_cast<StringData*>(nullstr_image);

#ifdef _MBCS
	for( int c=0; c<256; ++c )
		lb_[c] = (::IsDBCSLeadByte(c) ? 2 : 1);
#endif
}



//-------------------------------------------------------------------------

String::String( const TCHAR* s, long len )
{
	// w肪ꍇ͌vZ
	if( len==-1 )
		len = ::lstrlen(s);

	if( len==0 )
	{
		// 0p̓obt@
		SetData( null() );
	}
	else
	{
		// VKobt@쐬
		data_ = static_cast<StringData*>
		    (mem().Alloc( sizeof(StringData)+(len+1)*sizeof(TCHAR) ));
		data_->ref  = 1;
		data_->len  = len+1;
		data_->alen = len+1;
		memcpy( data_+1, s, (len+1)*sizeof(TCHAR) );
	}
}

inline void String::ReleaseData()
{
	if( --data_->ref <= 0 )
		mem().DeAlloc(
			data_, sizeof(StringData)+sizeof(TCHAR)*data_->alen );
}

String::~String()
{
	ReleaseData();
}

inline TCHAR* String::ReallocMem( ulong minimum=0 )
{
	return AllocMemHelper( minimum, c_str(), len()+1 );
}

String& String::SetString( const TCHAR* str, ulong siz )
{
	TCHAR* buf = AllocMem( siz+1 );

	memcpy( buf, str, siz*sizeof(TCHAR) );
	buf[siz] = TEXT('\0');

	UnlockMem( siz );
	return *this;
}

String& String::CatString( const TCHAR* str, ulong siz )
{
	const int plen = len();
	TCHAR* buf = ReallocMem( plen + siz + 1 );

	memcpy( buf+plen, str, siz*sizeof(TCHAR) );
	buf[plen+siz] = TEXT('\0');

	UnlockMem( plen+siz );
	return *this;
}

TCHAR* String::AllocMemHelper( ulong minimum, const TCHAR* str, ulong siz )
{
	if( data_->ref > 1 || data_->alen < minimum )
	{
		minimum = Max( minimum, data_->alen );

		StringData* pNew = static_cast<StringData*>
			(mem().Alloc( sizeof(StringData)+minimum*sizeof(TCHAR) ));
		pNew->ref  = 1;
		pNew->alen = minimum;
		pNew->len  = siz;
		memcpy( pNew->buf(), str, siz*sizeof(TCHAR) );

		ReleaseData();
		data_ = pNew;
	}

	return data_->buf();
}

String& String::operator = ( const String& obj )
{
	if( data() != obj.data() )
	{
		ReleaseData();
		SetData( obj.data() );
	}
	return *this;
}

String& String::Load( UINT rsrcID )
{
	const int step=256;

	// 256oCǧŒ蒷obt@ւ܂ǂł݂
	TCHAR tmp[step], *buf;
	int red = app().LoadString( rsrcID, tmp, countof(tmp) );
	if( countof(tmp) - red > 2 )
		return (*this = tmp);

	// ₵đΉĂ݂
	int siz = step;
	do
	{
		siz+= step;
		buf = AllocMem( siz );
		red = app().LoadString( rsrcID, buf, siz );
	} while( siz - red <= 2 );

	buf[red] = TEXT('\0');
	UnlockMem( red );
	return *this;
}

void String::TrimRight( ulong siz )
{
	if( siz >= len() )
	{
		ReleaseData();
		SetData( null() );
	}
	else
	{
		// obt@̎QƃJEgmɂPɂ
		ReallocMem();

		// w蕶
		data_->len -= siz;
		data_->buf()[data_->len-1] = TEXT('\0');
	}
}
